#include <iostream>
using namespace std;

int globalScope = 0; //This is a global variable, visible everywhere.

void foo() {
   int fooScope = 1; //Only visible within foo function
   cout << "fooScope: " << fooScope << endl;
   //cout << "localScope: " << localScope << endl; //Error! localScope is only visible in main()
}

int main() {
   cout << "globalScope: " << globalScope << endl; //OK! Will print 0

   { //Any block declares a scope, even this useless one
      int localScope = 3; 
      cout << "localScope: " << localScope << endl; //OK! Will print 3
      foo();
      //  cout << "fooScope: " << fooScope << endl; //Error! fooScope is out of scope
      int globalScope = 100; // variable hiding, very bad practice!
      cout << "globalScope: " << globalScope << endl; // Will print 100
   }

   //cout << "localScope: " << localScope << endl; //Error! localScope is out of scope
   cout << "globalScope: " << globalScope << endl;
}
